# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DatastreamArgs', 'Datastream']

@pulumi.input_type
class DatastreamArgs:
    def __init__(__self__, *,
                 active: pulumi.Input[bool],
                 contract_id: pulumi.Input[str],
                 dataset_fields: pulumi.Input[Sequence[pulumi.Input[int]]],
                 delivery_configuration: pulumi.Input['DatastreamDeliveryConfigurationArgs'],
                 group_id: pulumi.Input[str],
                 properties: pulumi.Input[Sequence[pulumi.Input[str]]],
                 stream_name: pulumi.Input[str],
                 azure_connector: Optional[pulumi.Input['DatastreamAzureConnectorArgs']] = None,
                 collect_midgress: Optional[pulumi.Input[bool]] = None,
                 datadog_connector: Optional[pulumi.Input['DatastreamDatadogConnectorArgs']] = None,
                 elasticsearch_connector: Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']] = None,
                 gcs_connector: Optional[pulumi.Input['DatastreamGcsConnectorArgs']] = None,
                 https_connector: Optional[pulumi.Input['DatastreamHttpsConnectorArgs']] = None,
                 loggly_connector: Optional[pulumi.Input['DatastreamLogglyConnectorArgs']] = None,
                 new_relic_connector: Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']] = None,
                 notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 oracle_connector: Optional[pulumi.Input['DatastreamOracleConnectorArgs']] = None,
                 s3_connector: Optional[pulumi.Input['DatastreamS3ConnectorArgs']] = None,
                 splunk_connector: Optional[pulumi.Input['DatastreamSplunkConnectorArgs']] = None,
                 sumologic_connector: Optional[pulumi.Input['DatastreamSumologicConnectorArgs']] = None):
        """
        The set of arguments for constructing a Datastream resource.
        :param pulumi.Input[bool] active: Defining if stream should be active or not
        :param pulumi.Input[str] contract_id: Identifies the contract that has access to the product
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dataset_fields: A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
               identifiers define how the value for these fields appear in the log lines
        :param pulumi.Input['DatastreamDeliveryConfigurationArgs'] delivery_configuration: Provides information about the configuration related to logs (format, file names, delivery frequency)
        :param pulumi.Input[str] group_id: Identifies the group that has access to the product and for which the stream configuration was created
        :param pulumi.Input[Sequence[pulumi.Input[str]]] properties: Identifies the properties monitored in the stream
        :param pulumi.Input[str] stream_name: The name of the stream
        :param pulumi.Input[bool] collect_midgress: Identifies if stream needs to collect midgress data
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notification_emails: List of email addresses where the system sends notifications about activations and deactivations of the stream
        """
        DatastreamArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            active=active,
            contract_id=contract_id,
            dataset_fields=dataset_fields,
            delivery_configuration=delivery_configuration,
            group_id=group_id,
            properties=properties,
            stream_name=stream_name,
            azure_connector=azure_connector,
            collect_midgress=collect_midgress,
            datadog_connector=datadog_connector,
            elasticsearch_connector=elasticsearch_connector,
            gcs_connector=gcs_connector,
            https_connector=https_connector,
            loggly_connector=loggly_connector,
            new_relic_connector=new_relic_connector,
            notification_emails=notification_emails,
            oracle_connector=oracle_connector,
            s3_connector=s3_connector,
            splunk_connector=splunk_connector,
            sumologic_connector=sumologic_connector,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             active: pulumi.Input[bool],
             contract_id: pulumi.Input[str],
             dataset_fields: pulumi.Input[Sequence[pulumi.Input[int]]],
             delivery_configuration: pulumi.Input['DatastreamDeliveryConfigurationArgs'],
             group_id: pulumi.Input[str],
             properties: pulumi.Input[Sequence[pulumi.Input[str]]],
             stream_name: pulumi.Input[str],
             azure_connector: Optional[pulumi.Input['DatastreamAzureConnectorArgs']] = None,
             collect_midgress: Optional[pulumi.Input[bool]] = None,
             datadog_connector: Optional[pulumi.Input['DatastreamDatadogConnectorArgs']] = None,
             elasticsearch_connector: Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']] = None,
             gcs_connector: Optional[pulumi.Input['DatastreamGcsConnectorArgs']] = None,
             https_connector: Optional[pulumi.Input['DatastreamHttpsConnectorArgs']] = None,
             loggly_connector: Optional[pulumi.Input['DatastreamLogglyConnectorArgs']] = None,
             new_relic_connector: Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']] = None,
             notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             oracle_connector: Optional[pulumi.Input['DatastreamOracleConnectorArgs']] = None,
             s3_connector: Optional[pulumi.Input['DatastreamS3ConnectorArgs']] = None,
             splunk_connector: Optional[pulumi.Input['DatastreamSplunkConnectorArgs']] = None,
             sumologic_connector: Optional[pulumi.Input['DatastreamSumologicConnectorArgs']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'contractId' in kwargs:
            contract_id = kwargs['contractId']
        if 'datasetFields' in kwargs:
            dataset_fields = kwargs['datasetFields']
        if 'deliveryConfiguration' in kwargs:
            delivery_configuration = kwargs['deliveryConfiguration']
        if 'groupId' in kwargs:
            group_id = kwargs['groupId']
        if 'streamName' in kwargs:
            stream_name = kwargs['streamName']
        if 'azureConnector' in kwargs:
            azure_connector = kwargs['azureConnector']
        if 'collectMidgress' in kwargs:
            collect_midgress = kwargs['collectMidgress']
        if 'datadogConnector' in kwargs:
            datadog_connector = kwargs['datadogConnector']
        if 'elasticsearchConnector' in kwargs:
            elasticsearch_connector = kwargs['elasticsearchConnector']
        if 'gcsConnector' in kwargs:
            gcs_connector = kwargs['gcsConnector']
        if 'httpsConnector' in kwargs:
            https_connector = kwargs['httpsConnector']
        if 'logglyConnector' in kwargs:
            loggly_connector = kwargs['logglyConnector']
        if 'newRelicConnector' in kwargs:
            new_relic_connector = kwargs['newRelicConnector']
        if 'notificationEmails' in kwargs:
            notification_emails = kwargs['notificationEmails']
        if 'oracleConnector' in kwargs:
            oracle_connector = kwargs['oracleConnector']
        if 's3Connector' in kwargs:
            s3_connector = kwargs['s3Connector']
        if 'splunkConnector' in kwargs:
            splunk_connector = kwargs['splunkConnector']
        if 'sumologicConnector' in kwargs:
            sumologic_connector = kwargs['sumologicConnector']

        _setter("active", active)
        _setter("contract_id", contract_id)
        _setter("dataset_fields", dataset_fields)
        _setter("delivery_configuration", delivery_configuration)
        _setter("group_id", group_id)
        _setter("properties", properties)
        _setter("stream_name", stream_name)
        if azure_connector is not None:
            _setter("azure_connector", azure_connector)
        if collect_midgress is not None:
            _setter("collect_midgress", collect_midgress)
        if datadog_connector is not None:
            _setter("datadog_connector", datadog_connector)
        if elasticsearch_connector is not None:
            _setter("elasticsearch_connector", elasticsearch_connector)
        if gcs_connector is not None:
            _setter("gcs_connector", gcs_connector)
        if https_connector is not None:
            _setter("https_connector", https_connector)
        if loggly_connector is not None:
            _setter("loggly_connector", loggly_connector)
        if new_relic_connector is not None:
            _setter("new_relic_connector", new_relic_connector)
        if notification_emails is not None:
            _setter("notification_emails", notification_emails)
        if oracle_connector is not None:
            _setter("oracle_connector", oracle_connector)
        if s3_connector is not None:
            _setter("s3_connector", s3_connector)
        if splunk_connector is not None:
            _setter("splunk_connector", splunk_connector)
        if sumologic_connector is not None:
            _setter("sumologic_connector", sumologic_connector)

    @property
    @pulumi.getter
    def active(self) -> pulumi.Input[bool]:
        """
        Defining if stream should be active or not
        """
        return pulumi.get(self, "active")

    @active.setter
    def active(self, value: pulumi.Input[bool]):
        pulumi.set(self, "active", value)

    @property
    @pulumi.getter(name="contractId")
    def contract_id(self) -> pulumi.Input[str]:
        """
        Identifies the contract that has access to the product
        """
        return pulumi.get(self, "contract_id")

    @contract_id.setter
    def contract_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "contract_id", value)

    @property
    @pulumi.getter(name="datasetFields")
    def dataset_fields(self) -> pulumi.Input[Sequence[pulumi.Input[int]]]:
        """
        A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
        identifiers define how the value for these fields appear in the log lines
        """
        return pulumi.get(self, "dataset_fields")

    @dataset_fields.setter
    def dataset_fields(self, value: pulumi.Input[Sequence[pulumi.Input[int]]]):
        pulumi.set(self, "dataset_fields", value)

    @property
    @pulumi.getter(name="deliveryConfiguration")
    def delivery_configuration(self) -> pulumi.Input['DatastreamDeliveryConfigurationArgs']:
        """
        Provides information about the configuration related to logs (format, file names, delivery frequency)
        """
        return pulumi.get(self, "delivery_configuration")

    @delivery_configuration.setter
    def delivery_configuration(self, value: pulumi.Input['DatastreamDeliveryConfigurationArgs']):
        pulumi.set(self, "delivery_configuration", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Input[str]:
        """
        Identifies the group that has access to the product and for which the stream configuration was created
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Identifies the properties monitored in the stream
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> pulumi.Input[str]:
        """
        The name of the stream
        """
        return pulumi.get(self, "stream_name")

    @stream_name.setter
    def stream_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "stream_name", value)

    @property
    @pulumi.getter(name="azureConnector")
    def azure_connector(self) -> Optional[pulumi.Input['DatastreamAzureConnectorArgs']]:
        return pulumi.get(self, "azure_connector")

    @azure_connector.setter
    def azure_connector(self, value: Optional[pulumi.Input['DatastreamAzureConnectorArgs']]):
        pulumi.set(self, "azure_connector", value)

    @property
    @pulumi.getter(name="collectMidgress")
    def collect_midgress(self) -> Optional[pulumi.Input[bool]]:
        """
        Identifies if stream needs to collect midgress data
        """
        return pulumi.get(self, "collect_midgress")

    @collect_midgress.setter
    def collect_midgress(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "collect_midgress", value)

    @property
    @pulumi.getter(name="datadogConnector")
    def datadog_connector(self) -> Optional[pulumi.Input['DatastreamDatadogConnectorArgs']]:
        return pulumi.get(self, "datadog_connector")

    @datadog_connector.setter
    def datadog_connector(self, value: Optional[pulumi.Input['DatastreamDatadogConnectorArgs']]):
        pulumi.set(self, "datadog_connector", value)

    @property
    @pulumi.getter(name="elasticsearchConnector")
    def elasticsearch_connector(self) -> Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']]:
        return pulumi.get(self, "elasticsearch_connector")

    @elasticsearch_connector.setter
    def elasticsearch_connector(self, value: Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']]):
        pulumi.set(self, "elasticsearch_connector", value)

    @property
    @pulumi.getter(name="gcsConnector")
    def gcs_connector(self) -> Optional[pulumi.Input['DatastreamGcsConnectorArgs']]:
        return pulumi.get(self, "gcs_connector")

    @gcs_connector.setter
    def gcs_connector(self, value: Optional[pulumi.Input['DatastreamGcsConnectorArgs']]):
        pulumi.set(self, "gcs_connector", value)

    @property
    @pulumi.getter(name="httpsConnector")
    def https_connector(self) -> Optional[pulumi.Input['DatastreamHttpsConnectorArgs']]:
        return pulumi.get(self, "https_connector")

    @https_connector.setter
    def https_connector(self, value: Optional[pulumi.Input['DatastreamHttpsConnectorArgs']]):
        pulumi.set(self, "https_connector", value)

    @property
    @pulumi.getter(name="logglyConnector")
    def loggly_connector(self) -> Optional[pulumi.Input['DatastreamLogglyConnectorArgs']]:
        return pulumi.get(self, "loggly_connector")

    @loggly_connector.setter
    def loggly_connector(self, value: Optional[pulumi.Input['DatastreamLogglyConnectorArgs']]):
        pulumi.set(self, "loggly_connector", value)

    @property
    @pulumi.getter(name="newRelicConnector")
    def new_relic_connector(self) -> Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']]:
        return pulumi.get(self, "new_relic_connector")

    @new_relic_connector.setter
    def new_relic_connector(self, value: Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']]):
        pulumi.set(self, "new_relic_connector", value)

    @property
    @pulumi.getter(name="notificationEmails")
    def notification_emails(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of email addresses where the system sends notifications about activations and deactivations of the stream
        """
        return pulumi.get(self, "notification_emails")

    @notification_emails.setter
    def notification_emails(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "notification_emails", value)

    @property
    @pulumi.getter(name="oracleConnector")
    def oracle_connector(self) -> Optional[pulumi.Input['DatastreamOracleConnectorArgs']]:
        return pulumi.get(self, "oracle_connector")

    @oracle_connector.setter
    def oracle_connector(self, value: Optional[pulumi.Input['DatastreamOracleConnectorArgs']]):
        pulumi.set(self, "oracle_connector", value)

    @property
    @pulumi.getter(name="s3Connector")
    def s3_connector(self) -> Optional[pulumi.Input['DatastreamS3ConnectorArgs']]:
        return pulumi.get(self, "s3_connector")

    @s3_connector.setter
    def s3_connector(self, value: Optional[pulumi.Input['DatastreamS3ConnectorArgs']]):
        pulumi.set(self, "s3_connector", value)

    @property
    @pulumi.getter(name="splunkConnector")
    def splunk_connector(self) -> Optional[pulumi.Input['DatastreamSplunkConnectorArgs']]:
        return pulumi.get(self, "splunk_connector")

    @splunk_connector.setter
    def splunk_connector(self, value: Optional[pulumi.Input['DatastreamSplunkConnectorArgs']]):
        pulumi.set(self, "splunk_connector", value)

    @property
    @pulumi.getter(name="sumologicConnector")
    def sumologic_connector(self) -> Optional[pulumi.Input['DatastreamSumologicConnectorArgs']]:
        return pulumi.get(self, "sumologic_connector")

    @sumologic_connector.setter
    def sumologic_connector(self, value: Optional[pulumi.Input['DatastreamSumologicConnectorArgs']]):
        pulumi.set(self, "sumologic_connector", value)


@pulumi.input_type
class _DatastreamState:
    def __init__(__self__, *,
                 active: Optional[pulumi.Input[bool]] = None,
                 azure_connector: Optional[pulumi.Input['DatastreamAzureConnectorArgs']] = None,
                 collect_midgress: Optional[pulumi.Input[bool]] = None,
                 contract_id: Optional[pulumi.Input[str]] = None,
                 created_by: Optional[pulumi.Input[str]] = None,
                 created_date: Optional[pulumi.Input[str]] = None,
                 datadog_connector: Optional[pulumi.Input['DatastreamDatadogConnectorArgs']] = None,
                 dataset_fields: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 delivery_configuration: Optional[pulumi.Input['DatastreamDeliveryConfigurationArgs']] = None,
                 elasticsearch_connector: Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']] = None,
                 gcs_connector: Optional[pulumi.Input['DatastreamGcsConnectorArgs']] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 https_connector: Optional[pulumi.Input['DatastreamHttpsConnectorArgs']] = None,
                 latest_version: Optional[pulumi.Input[int]] = None,
                 loggly_connector: Optional[pulumi.Input['DatastreamLogglyConnectorArgs']] = None,
                 modified_by: Optional[pulumi.Input[str]] = None,
                 modified_date: Optional[pulumi.Input[str]] = None,
                 new_relic_connector: Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']] = None,
                 notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 oracle_connector: Optional[pulumi.Input['DatastreamOracleConnectorArgs']] = None,
                 papi_json: Optional[pulumi.Input[str]] = None,
                 product_id: Optional[pulumi.Input[str]] = None,
                 properties: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 s3_connector: Optional[pulumi.Input['DatastreamS3ConnectorArgs']] = None,
                 splunk_connector: Optional[pulumi.Input['DatastreamSplunkConnectorArgs']] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 stream_version: Optional[pulumi.Input[int]] = None,
                 sumologic_connector: Optional[pulumi.Input['DatastreamSumologicConnectorArgs']] = None):
        """
        Input properties used for looking up and filtering Datastream resources.
        :param pulumi.Input[bool] active: Defining if stream should be active or not
        :param pulumi.Input[bool] collect_midgress: Identifies if stream needs to collect midgress data
        :param pulumi.Input[str] contract_id: Identifies the contract that has access to the product
        :param pulumi.Input[str] created_by: The username who created the stream
        :param pulumi.Input[str] created_date: The date and time when the stream was created
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dataset_fields: A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
               identifiers define how the value for these fields appear in the log lines
        :param pulumi.Input['DatastreamDeliveryConfigurationArgs'] delivery_configuration: Provides information about the configuration related to logs (format, file names, delivery frequency)
        :param pulumi.Input[str] group_id: Identifies the group that has access to the product and for which the stream configuration was created
        :param pulumi.Input[int] latest_version: Identifies the latest active configuration version of the stream
        :param pulumi.Input[str] modified_by: The username who modified the stream
        :param pulumi.Input[str] modified_date: The date and time when the stream was modified
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notification_emails: List of email addresses where the system sends notifications about activations and deactivations of the stream
        :param pulumi.Input[str] papi_json: The configuration in JSON format that can be copy-pasted into PAPI configuration to enable datastream behavior
        :param pulumi.Input[str] product_id: The ID of the product for which the stream was created
        :param pulumi.Input[Sequence[pulumi.Input[str]]] properties: Identifies the properties monitored in the stream
        :param pulumi.Input[str] stream_name: The name of the stream
        :param pulumi.Input[int] stream_version: Identifies the configuration version of the stream
        """
        _DatastreamState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            active=active,
            azure_connector=azure_connector,
            collect_midgress=collect_midgress,
            contract_id=contract_id,
            created_by=created_by,
            created_date=created_date,
            datadog_connector=datadog_connector,
            dataset_fields=dataset_fields,
            delivery_configuration=delivery_configuration,
            elasticsearch_connector=elasticsearch_connector,
            gcs_connector=gcs_connector,
            group_id=group_id,
            https_connector=https_connector,
            latest_version=latest_version,
            loggly_connector=loggly_connector,
            modified_by=modified_by,
            modified_date=modified_date,
            new_relic_connector=new_relic_connector,
            notification_emails=notification_emails,
            oracle_connector=oracle_connector,
            papi_json=papi_json,
            product_id=product_id,
            properties=properties,
            s3_connector=s3_connector,
            splunk_connector=splunk_connector,
            stream_name=stream_name,
            stream_version=stream_version,
            sumologic_connector=sumologic_connector,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             active: Optional[pulumi.Input[bool]] = None,
             azure_connector: Optional[pulumi.Input['DatastreamAzureConnectorArgs']] = None,
             collect_midgress: Optional[pulumi.Input[bool]] = None,
             contract_id: Optional[pulumi.Input[str]] = None,
             created_by: Optional[pulumi.Input[str]] = None,
             created_date: Optional[pulumi.Input[str]] = None,
             datadog_connector: Optional[pulumi.Input['DatastreamDatadogConnectorArgs']] = None,
             dataset_fields: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
             delivery_configuration: Optional[pulumi.Input['DatastreamDeliveryConfigurationArgs']] = None,
             elasticsearch_connector: Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']] = None,
             gcs_connector: Optional[pulumi.Input['DatastreamGcsConnectorArgs']] = None,
             group_id: Optional[pulumi.Input[str]] = None,
             https_connector: Optional[pulumi.Input['DatastreamHttpsConnectorArgs']] = None,
             latest_version: Optional[pulumi.Input[int]] = None,
             loggly_connector: Optional[pulumi.Input['DatastreamLogglyConnectorArgs']] = None,
             modified_by: Optional[pulumi.Input[str]] = None,
             modified_date: Optional[pulumi.Input[str]] = None,
             new_relic_connector: Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']] = None,
             notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             oracle_connector: Optional[pulumi.Input['DatastreamOracleConnectorArgs']] = None,
             papi_json: Optional[pulumi.Input[str]] = None,
             product_id: Optional[pulumi.Input[str]] = None,
             properties: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             s3_connector: Optional[pulumi.Input['DatastreamS3ConnectorArgs']] = None,
             splunk_connector: Optional[pulumi.Input['DatastreamSplunkConnectorArgs']] = None,
             stream_name: Optional[pulumi.Input[str]] = None,
             stream_version: Optional[pulumi.Input[int]] = None,
             sumologic_connector: Optional[pulumi.Input['DatastreamSumologicConnectorArgs']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'azureConnector' in kwargs:
            azure_connector = kwargs['azureConnector']
        if 'collectMidgress' in kwargs:
            collect_midgress = kwargs['collectMidgress']
        if 'contractId' in kwargs:
            contract_id = kwargs['contractId']
        if 'createdBy' in kwargs:
            created_by = kwargs['createdBy']
        if 'createdDate' in kwargs:
            created_date = kwargs['createdDate']
        if 'datadogConnector' in kwargs:
            datadog_connector = kwargs['datadogConnector']
        if 'datasetFields' in kwargs:
            dataset_fields = kwargs['datasetFields']
        if 'deliveryConfiguration' in kwargs:
            delivery_configuration = kwargs['deliveryConfiguration']
        if 'elasticsearchConnector' in kwargs:
            elasticsearch_connector = kwargs['elasticsearchConnector']
        if 'gcsConnector' in kwargs:
            gcs_connector = kwargs['gcsConnector']
        if 'groupId' in kwargs:
            group_id = kwargs['groupId']
        if 'httpsConnector' in kwargs:
            https_connector = kwargs['httpsConnector']
        if 'latestVersion' in kwargs:
            latest_version = kwargs['latestVersion']
        if 'logglyConnector' in kwargs:
            loggly_connector = kwargs['logglyConnector']
        if 'modifiedBy' in kwargs:
            modified_by = kwargs['modifiedBy']
        if 'modifiedDate' in kwargs:
            modified_date = kwargs['modifiedDate']
        if 'newRelicConnector' in kwargs:
            new_relic_connector = kwargs['newRelicConnector']
        if 'notificationEmails' in kwargs:
            notification_emails = kwargs['notificationEmails']
        if 'oracleConnector' in kwargs:
            oracle_connector = kwargs['oracleConnector']
        if 'papiJson' in kwargs:
            papi_json = kwargs['papiJson']
        if 'productId' in kwargs:
            product_id = kwargs['productId']
        if 's3Connector' in kwargs:
            s3_connector = kwargs['s3Connector']
        if 'splunkConnector' in kwargs:
            splunk_connector = kwargs['splunkConnector']
        if 'streamName' in kwargs:
            stream_name = kwargs['streamName']
        if 'streamVersion' in kwargs:
            stream_version = kwargs['streamVersion']
        if 'sumologicConnector' in kwargs:
            sumologic_connector = kwargs['sumologicConnector']

        if active is not None:
            _setter("active", active)
        if azure_connector is not None:
            _setter("azure_connector", azure_connector)
        if collect_midgress is not None:
            _setter("collect_midgress", collect_midgress)
        if contract_id is not None:
            _setter("contract_id", contract_id)
        if created_by is not None:
            _setter("created_by", created_by)
        if created_date is not None:
            _setter("created_date", created_date)
        if datadog_connector is not None:
            _setter("datadog_connector", datadog_connector)
        if dataset_fields is not None:
            _setter("dataset_fields", dataset_fields)
        if delivery_configuration is not None:
            _setter("delivery_configuration", delivery_configuration)
        if elasticsearch_connector is not None:
            _setter("elasticsearch_connector", elasticsearch_connector)
        if gcs_connector is not None:
            _setter("gcs_connector", gcs_connector)
        if group_id is not None:
            _setter("group_id", group_id)
        if https_connector is not None:
            _setter("https_connector", https_connector)
        if latest_version is not None:
            _setter("latest_version", latest_version)
        if loggly_connector is not None:
            _setter("loggly_connector", loggly_connector)
        if modified_by is not None:
            _setter("modified_by", modified_by)
        if modified_date is not None:
            _setter("modified_date", modified_date)
        if new_relic_connector is not None:
            _setter("new_relic_connector", new_relic_connector)
        if notification_emails is not None:
            _setter("notification_emails", notification_emails)
        if oracle_connector is not None:
            _setter("oracle_connector", oracle_connector)
        if papi_json is not None:
            _setter("papi_json", papi_json)
        if product_id is not None:
            _setter("product_id", product_id)
        if properties is not None:
            _setter("properties", properties)
        if s3_connector is not None:
            _setter("s3_connector", s3_connector)
        if splunk_connector is not None:
            _setter("splunk_connector", splunk_connector)
        if stream_name is not None:
            _setter("stream_name", stream_name)
        if stream_version is not None:
            _setter("stream_version", stream_version)
        if sumologic_connector is not None:
            _setter("sumologic_connector", sumologic_connector)

    @property
    @pulumi.getter
    def active(self) -> Optional[pulumi.Input[bool]]:
        """
        Defining if stream should be active or not
        """
        return pulumi.get(self, "active")

    @active.setter
    def active(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "active", value)

    @property
    @pulumi.getter(name="azureConnector")
    def azure_connector(self) -> Optional[pulumi.Input['DatastreamAzureConnectorArgs']]:
        return pulumi.get(self, "azure_connector")

    @azure_connector.setter
    def azure_connector(self, value: Optional[pulumi.Input['DatastreamAzureConnectorArgs']]):
        pulumi.set(self, "azure_connector", value)

    @property
    @pulumi.getter(name="collectMidgress")
    def collect_midgress(self) -> Optional[pulumi.Input[bool]]:
        """
        Identifies if stream needs to collect midgress data
        """
        return pulumi.get(self, "collect_midgress")

    @collect_midgress.setter
    def collect_midgress(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "collect_midgress", value)

    @property
    @pulumi.getter(name="contractId")
    def contract_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifies the contract that has access to the product
        """
        return pulumi.get(self, "contract_id")

    @contract_id.setter
    def contract_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "contract_id", value)

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[pulumi.Input[str]]:
        """
        The username who created the stream
        """
        return pulumi.get(self, "created_by")

    @created_by.setter
    def created_by(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_by", value)

    @property
    @pulumi.getter(name="createdDate")
    def created_date(self) -> Optional[pulumi.Input[str]]:
        """
        The date and time when the stream was created
        """
        return pulumi.get(self, "created_date")

    @created_date.setter
    def created_date(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_date", value)

    @property
    @pulumi.getter(name="datadogConnector")
    def datadog_connector(self) -> Optional[pulumi.Input['DatastreamDatadogConnectorArgs']]:
        return pulumi.get(self, "datadog_connector")

    @datadog_connector.setter
    def datadog_connector(self, value: Optional[pulumi.Input['DatastreamDatadogConnectorArgs']]):
        pulumi.set(self, "datadog_connector", value)

    @property
    @pulumi.getter(name="datasetFields")
    def dataset_fields(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
        identifiers define how the value for these fields appear in the log lines
        """
        return pulumi.get(self, "dataset_fields")

    @dataset_fields.setter
    def dataset_fields(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "dataset_fields", value)

    @property
    @pulumi.getter(name="deliveryConfiguration")
    def delivery_configuration(self) -> Optional[pulumi.Input['DatastreamDeliveryConfigurationArgs']]:
        """
        Provides information about the configuration related to logs (format, file names, delivery frequency)
        """
        return pulumi.get(self, "delivery_configuration")

    @delivery_configuration.setter
    def delivery_configuration(self, value: Optional[pulumi.Input['DatastreamDeliveryConfigurationArgs']]):
        pulumi.set(self, "delivery_configuration", value)

    @property
    @pulumi.getter(name="elasticsearchConnector")
    def elasticsearch_connector(self) -> Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']]:
        return pulumi.get(self, "elasticsearch_connector")

    @elasticsearch_connector.setter
    def elasticsearch_connector(self, value: Optional[pulumi.Input['DatastreamElasticsearchConnectorArgs']]):
        pulumi.set(self, "elasticsearch_connector", value)

    @property
    @pulumi.getter(name="gcsConnector")
    def gcs_connector(self) -> Optional[pulumi.Input['DatastreamGcsConnectorArgs']]:
        return pulumi.get(self, "gcs_connector")

    @gcs_connector.setter
    def gcs_connector(self, value: Optional[pulumi.Input['DatastreamGcsConnectorArgs']]):
        pulumi.set(self, "gcs_connector", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifies the group that has access to the product and for which the stream configuration was created
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter(name="httpsConnector")
    def https_connector(self) -> Optional[pulumi.Input['DatastreamHttpsConnectorArgs']]:
        return pulumi.get(self, "https_connector")

    @https_connector.setter
    def https_connector(self, value: Optional[pulumi.Input['DatastreamHttpsConnectorArgs']]):
        pulumi.set(self, "https_connector", value)

    @property
    @pulumi.getter(name="latestVersion")
    def latest_version(self) -> Optional[pulumi.Input[int]]:
        """
        Identifies the latest active configuration version of the stream
        """
        return pulumi.get(self, "latest_version")

    @latest_version.setter
    def latest_version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "latest_version", value)

    @property
    @pulumi.getter(name="logglyConnector")
    def loggly_connector(self) -> Optional[pulumi.Input['DatastreamLogglyConnectorArgs']]:
        return pulumi.get(self, "loggly_connector")

    @loggly_connector.setter
    def loggly_connector(self, value: Optional[pulumi.Input['DatastreamLogglyConnectorArgs']]):
        pulumi.set(self, "loggly_connector", value)

    @property
    @pulumi.getter(name="modifiedBy")
    def modified_by(self) -> Optional[pulumi.Input[str]]:
        """
        The username who modified the stream
        """
        return pulumi.get(self, "modified_by")

    @modified_by.setter
    def modified_by(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "modified_by", value)

    @property
    @pulumi.getter(name="modifiedDate")
    def modified_date(self) -> Optional[pulumi.Input[str]]:
        """
        The date and time when the stream was modified
        """
        return pulumi.get(self, "modified_date")

    @modified_date.setter
    def modified_date(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "modified_date", value)

    @property
    @pulumi.getter(name="newRelicConnector")
    def new_relic_connector(self) -> Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']]:
        return pulumi.get(self, "new_relic_connector")

    @new_relic_connector.setter
    def new_relic_connector(self, value: Optional[pulumi.Input['DatastreamNewRelicConnectorArgs']]):
        pulumi.set(self, "new_relic_connector", value)

    @property
    @pulumi.getter(name="notificationEmails")
    def notification_emails(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of email addresses where the system sends notifications about activations and deactivations of the stream
        """
        return pulumi.get(self, "notification_emails")

    @notification_emails.setter
    def notification_emails(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "notification_emails", value)

    @property
    @pulumi.getter(name="oracleConnector")
    def oracle_connector(self) -> Optional[pulumi.Input['DatastreamOracleConnectorArgs']]:
        return pulumi.get(self, "oracle_connector")

    @oracle_connector.setter
    def oracle_connector(self, value: Optional[pulumi.Input['DatastreamOracleConnectorArgs']]):
        pulumi.set(self, "oracle_connector", value)

    @property
    @pulumi.getter(name="papiJson")
    def papi_json(self) -> Optional[pulumi.Input[str]]:
        """
        The configuration in JSON format that can be copy-pasted into PAPI configuration to enable datastream behavior
        """
        return pulumi.get(self, "papi_json")

    @papi_json.setter
    def papi_json(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "papi_json", value)

    @property
    @pulumi.getter(name="productId")
    def product_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the product for which the stream was created
        """
        return pulumi.get(self, "product_id")

    @product_id.setter
    def product_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "product_id", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Identifies the properties monitored in the stream
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="s3Connector")
    def s3_connector(self) -> Optional[pulumi.Input['DatastreamS3ConnectorArgs']]:
        return pulumi.get(self, "s3_connector")

    @s3_connector.setter
    def s3_connector(self, value: Optional[pulumi.Input['DatastreamS3ConnectorArgs']]):
        pulumi.set(self, "s3_connector", value)

    @property
    @pulumi.getter(name="splunkConnector")
    def splunk_connector(self) -> Optional[pulumi.Input['DatastreamSplunkConnectorArgs']]:
        return pulumi.get(self, "splunk_connector")

    @splunk_connector.setter
    def splunk_connector(self, value: Optional[pulumi.Input['DatastreamSplunkConnectorArgs']]):
        pulumi.set(self, "splunk_connector", value)

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the stream
        """
        return pulumi.get(self, "stream_name")

    @stream_name.setter
    def stream_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stream_name", value)

    @property
    @pulumi.getter(name="streamVersion")
    def stream_version(self) -> Optional[pulumi.Input[int]]:
        """
        Identifies the configuration version of the stream
        """
        return pulumi.get(self, "stream_version")

    @stream_version.setter
    def stream_version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "stream_version", value)

    @property
    @pulumi.getter(name="sumologicConnector")
    def sumologic_connector(self) -> Optional[pulumi.Input['DatastreamSumologicConnectorArgs']]:
        return pulumi.get(self, "sumologic_connector")

    @sumologic_connector.setter
    def sumologic_connector(self, value: Optional[pulumi.Input['DatastreamSumologicConnectorArgs']]):
        pulumi.set(self, "sumologic_connector", value)


class Datastream(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 active: Optional[pulumi.Input[bool]] = None,
                 azure_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamAzureConnectorArgs']]] = None,
                 collect_midgress: Optional[pulumi.Input[bool]] = None,
                 contract_id: Optional[pulumi.Input[str]] = None,
                 datadog_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamDatadogConnectorArgs']]] = None,
                 dataset_fields: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 delivery_configuration: Optional[pulumi.Input[pulumi.InputType['DatastreamDeliveryConfigurationArgs']]] = None,
                 elasticsearch_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamElasticsearchConnectorArgs']]] = None,
                 gcs_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamGcsConnectorArgs']]] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 https_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamHttpsConnectorArgs']]] = None,
                 loggly_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamLogglyConnectorArgs']]] = None,
                 new_relic_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamNewRelicConnectorArgs']]] = None,
                 notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 oracle_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamOracleConnectorArgs']]] = None,
                 properties: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 s3_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamS3ConnectorArgs']]] = None,
                 splunk_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamSplunkConnectorArgs']]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 sumologic_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamSumologicConnectorArgs']]] = None,
                 __props__=None):
        """
        Create a Datastream resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] active: Defining if stream should be active or not
        :param pulumi.Input[bool] collect_midgress: Identifies if stream needs to collect midgress data
        :param pulumi.Input[str] contract_id: Identifies the contract that has access to the product
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dataset_fields: A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
               identifiers define how the value for these fields appear in the log lines
        :param pulumi.Input[pulumi.InputType['DatastreamDeliveryConfigurationArgs']] delivery_configuration: Provides information about the configuration related to logs (format, file names, delivery frequency)
        :param pulumi.Input[str] group_id: Identifies the group that has access to the product and for which the stream configuration was created
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notification_emails: List of email addresses where the system sends notifications about activations and deactivations of the stream
        :param pulumi.Input[Sequence[pulumi.Input[str]]] properties: Identifies the properties monitored in the stream
        :param pulumi.Input[str] stream_name: The name of the stream
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DatastreamArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Datastream resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DatastreamArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatastreamArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            DatastreamArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 active: Optional[pulumi.Input[bool]] = None,
                 azure_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamAzureConnectorArgs']]] = None,
                 collect_midgress: Optional[pulumi.Input[bool]] = None,
                 contract_id: Optional[pulumi.Input[str]] = None,
                 datadog_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamDatadogConnectorArgs']]] = None,
                 dataset_fields: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 delivery_configuration: Optional[pulumi.Input[pulumi.InputType['DatastreamDeliveryConfigurationArgs']]] = None,
                 elasticsearch_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamElasticsearchConnectorArgs']]] = None,
                 gcs_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamGcsConnectorArgs']]] = None,
                 group_id: Optional[pulumi.Input[str]] = None,
                 https_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamHttpsConnectorArgs']]] = None,
                 loggly_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamLogglyConnectorArgs']]] = None,
                 new_relic_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamNewRelicConnectorArgs']]] = None,
                 notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 oracle_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamOracleConnectorArgs']]] = None,
                 properties: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 s3_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamS3ConnectorArgs']]] = None,
                 splunk_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamSplunkConnectorArgs']]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 sumologic_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamSumologicConnectorArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatastreamArgs.__new__(DatastreamArgs)

            if active is None and not opts.urn:
                raise TypeError("Missing required property 'active'")
            __props__.__dict__["active"] = active
            if azure_connector is not None and not isinstance(azure_connector, DatastreamAzureConnectorArgs):
                azure_connector = azure_connector or {}
                def _setter(key, value):
                    azure_connector[key] = value
                DatastreamAzureConnectorArgs._configure(_setter, **azure_connector)
            __props__.__dict__["azure_connector"] = azure_connector
            __props__.__dict__["collect_midgress"] = collect_midgress
            if contract_id is None and not opts.urn:
                raise TypeError("Missing required property 'contract_id'")
            __props__.__dict__["contract_id"] = contract_id
            if datadog_connector is not None and not isinstance(datadog_connector, DatastreamDatadogConnectorArgs):
                datadog_connector = datadog_connector or {}
                def _setter(key, value):
                    datadog_connector[key] = value
                DatastreamDatadogConnectorArgs._configure(_setter, **datadog_connector)
            __props__.__dict__["datadog_connector"] = datadog_connector
            if dataset_fields is None and not opts.urn:
                raise TypeError("Missing required property 'dataset_fields'")
            __props__.__dict__["dataset_fields"] = dataset_fields
            if delivery_configuration is not None and not isinstance(delivery_configuration, DatastreamDeliveryConfigurationArgs):
                delivery_configuration = delivery_configuration or {}
                def _setter(key, value):
                    delivery_configuration[key] = value
                DatastreamDeliveryConfigurationArgs._configure(_setter, **delivery_configuration)
            if delivery_configuration is None and not opts.urn:
                raise TypeError("Missing required property 'delivery_configuration'")
            __props__.__dict__["delivery_configuration"] = delivery_configuration
            if elasticsearch_connector is not None and not isinstance(elasticsearch_connector, DatastreamElasticsearchConnectorArgs):
                elasticsearch_connector = elasticsearch_connector or {}
                def _setter(key, value):
                    elasticsearch_connector[key] = value
                DatastreamElasticsearchConnectorArgs._configure(_setter, **elasticsearch_connector)
            __props__.__dict__["elasticsearch_connector"] = elasticsearch_connector
            if gcs_connector is not None and not isinstance(gcs_connector, DatastreamGcsConnectorArgs):
                gcs_connector = gcs_connector or {}
                def _setter(key, value):
                    gcs_connector[key] = value
                DatastreamGcsConnectorArgs._configure(_setter, **gcs_connector)
            __props__.__dict__["gcs_connector"] = gcs_connector
            if group_id is None and not opts.urn:
                raise TypeError("Missing required property 'group_id'")
            __props__.__dict__["group_id"] = group_id
            if https_connector is not None and not isinstance(https_connector, DatastreamHttpsConnectorArgs):
                https_connector = https_connector or {}
                def _setter(key, value):
                    https_connector[key] = value
                DatastreamHttpsConnectorArgs._configure(_setter, **https_connector)
            __props__.__dict__["https_connector"] = https_connector
            if loggly_connector is not None and not isinstance(loggly_connector, DatastreamLogglyConnectorArgs):
                loggly_connector = loggly_connector or {}
                def _setter(key, value):
                    loggly_connector[key] = value
                DatastreamLogglyConnectorArgs._configure(_setter, **loggly_connector)
            __props__.__dict__["loggly_connector"] = loggly_connector
            if new_relic_connector is not None and not isinstance(new_relic_connector, DatastreamNewRelicConnectorArgs):
                new_relic_connector = new_relic_connector or {}
                def _setter(key, value):
                    new_relic_connector[key] = value
                DatastreamNewRelicConnectorArgs._configure(_setter, **new_relic_connector)
            __props__.__dict__["new_relic_connector"] = new_relic_connector
            __props__.__dict__["notification_emails"] = notification_emails
            if oracle_connector is not None and not isinstance(oracle_connector, DatastreamOracleConnectorArgs):
                oracle_connector = oracle_connector or {}
                def _setter(key, value):
                    oracle_connector[key] = value
                DatastreamOracleConnectorArgs._configure(_setter, **oracle_connector)
            __props__.__dict__["oracle_connector"] = oracle_connector
            if properties is None and not opts.urn:
                raise TypeError("Missing required property 'properties'")
            __props__.__dict__["properties"] = properties
            if s3_connector is not None and not isinstance(s3_connector, DatastreamS3ConnectorArgs):
                s3_connector = s3_connector or {}
                def _setter(key, value):
                    s3_connector[key] = value
                DatastreamS3ConnectorArgs._configure(_setter, **s3_connector)
            __props__.__dict__["s3_connector"] = s3_connector
            if splunk_connector is not None and not isinstance(splunk_connector, DatastreamSplunkConnectorArgs):
                splunk_connector = splunk_connector or {}
                def _setter(key, value):
                    splunk_connector[key] = value
                DatastreamSplunkConnectorArgs._configure(_setter, **splunk_connector)
            __props__.__dict__["splunk_connector"] = splunk_connector
            if stream_name is None and not opts.urn:
                raise TypeError("Missing required property 'stream_name'")
            __props__.__dict__["stream_name"] = stream_name
            if sumologic_connector is not None and not isinstance(sumologic_connector, DatastreamSumologicConnectorArgs):
                sumologic_connector = sumologic_connector or {}
                def _setter(key, value):
                    sumologic_connector[key] = value
                DatastreamSumologicConnectorArgs._configure(_setter, **sumologic_connector)
            __props__.__dict__["sumologic_connector"] = sumologic_connector
            __props__.__dict__["created_by"] = None
            __props__.__dict__["created_date"] = None
            __props__.__dict__["latest_version"] = None
            __props__.__dict__["modified_by"] = None
            __props__.__dict__["modified_date"] = None
            __props__.__dict__["papi_json"] = None
            __props__.__dict__["product_id"] = None
            __props__.__dict__["stream_version"] = None
        super(Datastream, __self__).__init__(
            'akamai:index/datastream:Datastream',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            active: Optional[pulumi.Input[bool]] = None,
            azure_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamAzureConnectorArgs']]] = None,
            collect_midgress: Optional[pulumi.Input[bool]] = None,
            contract_id: Optional[pulumi.Input[str]] = None,
            created_by: Optional[pulumi.Input[str]] = None,
            created_date: Optional[pulumi.Input[str]] = None,
            datadog_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamDatadogConnectorArgs']]] = None,
            dataset_fields: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            delivery_configuration: Optional[pulumi.Input[pulumi.InputType['DatastreamDeliveryConfigurationArgs']]] = None,
            elasticsearch_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamElasticsearchConnectorArgs']]] = None,
            gcs_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamGcsConnectorArgs']]] = None,
            group_id: Optional[pulumi.Input[str]] = None,
            https_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamHttpsConnectorArgs']]] = None,
            latest_version: Optional[pulumi.Input[int]] = None,
            loggly_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamLogglyConnectorArgs']]] = None,
            modified_by: Optional[pulumi.Input[str]] = None,
            modified_date: Optional[pulumi.Input[str]] = None,
            new_relic_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamNewRelicConnectorArgs']]] = None,
            notification_emails: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            oracle_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamOracleConnectorArgs']]] = None,
            papi_json: Optional[pulumi.Input[str]] = None,
            product_id: Optional[pulumi.Input[str]] = None,
            properties: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            s3_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamS3ConnectorArgs']]] = None,
            splunk_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamSplunkConnectorArgs']]] = None,
            stream_name: Optional[pulumi.Input[str]] = None,
            stream_version: Optional[pulumi.Input[int]] = None,
            sumologic_connector: Optional[pulumi.Input[pulumi.InputType['DatastreamSumologicConnectorArgs']]] = None) -> 'Datastream':
        """
        Get an existing Datastream resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] active: Defining if stream should be active or not
        :param pulumi.Input[bool] collect_midgress: Identifies if stream needs to collect midgress data
        :param pulumi.Input[str] contract_id: Identifies the contract that has access to the product
        :param pulumi.Input[str] created_by: The username who created the stream
        :param pulumi.Input[str] created_date: The date and time when the stream was created
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dataset_fields: A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
               identifiers define how the value for these fields appear in the log lines
        :param pulumi.Input[pulumi.InputType['DatastreamDeliveryConfigurationArgs']] delivery_configuration: Provides information about the configuration related to logs (format, file names, delivery frequency)
        :param pulumi.Input[str] group_id: Identifies the group that has access to the product and for which the stream configuration was created
        :param pulumi.Input[int] latest_version: Identifies the latest active configuration version of the stream
        :param pulumi.Input[str] modified_by: The username who modified the stream
        :param pulumi.Input[str] modified_date: The date and time when the stream was modified
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notification_emails: List of email addresses where the system sends notifications about activations and deactivations of the stream
        :param pulumi.Input[str] papi_json: The configuration in JSON format that can be copy-pasted into PAPI configuration to enable datastream behavior
        :param pulumi.Input[str] product_id: The ID of the product for which the stream was created
        :param pulumi.Input[Sequence[pulumi.Input[str]]] properties: Identifies the properties monitored in the stream
        :param pulumi.Input[str] stream_name: The name of the stream
        :param pulumi.Input[int] stream_version: Identifies the configuration version of the stream
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DatastreamState.__new__(_DatastreamState)

        __props__.__dict__["active"] = active
        __props__.__dict__["azure_connector"] = azure_connector
        __props__.__dict__["collect_midgress"] = collect_midgress
        __props__.__dict__["contract_id"] = contract_id
        __props__.__dict__["created_by"] = created_by
        __props__.__dict__["created_date"] = created_date
        __props__.__dict__["datadog_connector"] = datadog_connector
        __props__.__dict__["dataset_fields"] = dataset_fields
        __props__.__dict__["delivery_configuration"] = delivery_configuration
        __props__.__dict__["elasticsearch_connector"] = elasticsearch_connector
        __props__.__dict__["gcs_connector"] = gcs_connector
        __props__.__dict__["group_id"] = group_id
        __props__.__dict__["https_connector"] = https_connector
        __props__.__dict__["latest_version"] = latest_version
        __props__.__dict__["loggly_connector"] = loggly_connector
        __props__.__dict__["modified_by"] = modified_by
        __props__.__dict__["modified_date"] = modified_date
        __props__.__dict__["new_relic_connector"] = new_relic_connector
        __props__.__dict__["notification_emails"] = notification_emails
        __props__.__dict__["oracle_connector"] = oracle_connector
        __props__.__dict__["papi_json"] = papi_json
        __props__.__dict__["product_id"] = product_id
        __props__.__dict__["properties"] = properties
        __props__.__dict__["s3_connector"] = s3_connector
        __props__.__dict__["splunk_connector"] = splunk_connector
        __props__.__dict__["stream_name"] = stream_name
        __props__.__dict__["stream_version"] = stream_version
        __props__.__dict__["sumologic_connector"] = sumologic_connector
        return Datastream(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def active(self) -> pulumi.Output[bool]:
        """
        Defining if stream should be active or not
        """
        return pulumi.get(self, "active")

    @property
    @pulumi.getter(name="azureConnector")
    def azure_connector(self) -> pulumi.Output[Optional['outputs.DatastreamAzureConnector']]:
        return pulumi.get(self, "azure_connector")

    @property
    @pulumi.getter(name="collectMidgress")
    def collect_midgress(self) -> pulumi.Output[Optional[bool]]:
        """
        Identifies if stream needs to collect midgress data
        """
        return pulumi.get(self, "collect_midgress")

    @property
    @pulumi.getter(name="contractId")
    def contract_id(self) -> pulumi.Output[str]:
        """
        Identifies the contract that has access to the product
        """
        return pulumi.get(self, "contract_id")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> pulumi.Output[str]:
        """
        The username who created the stream
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdDate")
    def created_date(self) -> pulumi.Output[str]:
        """
        The date and time when the stream was created
        """
        return pulumi.get(self, "created_date")

    @property
    @pulumi.getter(name="datadogConnector")
    def datadog_connector(self) -> pulumi.Output[Optional['outputs.DatastreamDatadogConnector']]:
        return pulumi.get(self, "datadog_connector")

    @property
    @pulumi.getter(name="datasetFields")
    def dataset_fields(self) -> pulumi.Output[Sequence[int]]:
        """
        A list of data set fields selected from the associated template that the stream monitors in logs. The order of the
        identifiers define how the value for these fields appear in the log lines
        """
        return pulumi.get(self, "dataset_fields")

    @property
    @pulumi.getter(name="deliveryConfiguration")
    def delivery_configuration(self) -> pulumi.Output['outputs.DatastreamDeliveryConfiguration']:
        """
        Provides information about the configuration related to logs (format, file names, delivery frequency)
        """
        return pulumi.get(self, "delivery_configuration")

    @property
    @pulumi.getter(name="elasticsearchConnector")
    def elasticsearch_connector(self) -> pulumi.Output[Optional['outputs.DatastreamElasticsearchConnector']]:
        return pulumi.get(self, "elasticsearch_connector")

    @property
    @pulumi.getter(name="gcsConnector")
    def gcs_connector(self) -> pulumi.Output[Optional['outputs.DatastreamGcsConnector']]:
        return pulumi.get(self, "gcs_connector")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Output[str]:
        """
        Identifies the group that has access to the product and for which the stream configuration was created
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="httpsConnector")
    def https_connector(self) -> pulumi.Output[Optional['outputs.DatastreamHttpsConnector']]:
        return pulumi.get(self, "https_connector")

    @property
    @pulumi.getter(name="latestVersion")
    def latest_version(self) -> pulumi.Output[int]:
        """
        Identifies the latest active configuration version of the stream
        """
        return pulumi.get(self, "latest_version")

    @property
    @pulumi.getter(name="logglyConnector")
    def loggly_connector(self) -> pulumi.Output[Optional['outputs.DatastreamLogglyConnector']]:
        return pulumi.get(self, "loggly_connector")

    @property
    @pulumi.getter(name="modifiedBy")
    def modified_by(self) -> pulumi.Output[str]:
        """
        The username who modified the stream
        """
        return pulumi.get(self, "modified_by")

    @property
    @pulumi.getter(name="modifiedDate")
    def modified_date(self) -> pulumi.Output[str]:
        """
        The date and time when the stream was modified
        """
        return pulumi.get(self, "modified_date")

    @property
    @pulumi.getter(name="newRelicConnector")
    def new_relic_connector(self) -> pulumi.Output[Optional['outputs.DatastreamNewRelicConnector']]:
        return pulumi.get(self, "new_relic_connector")

    @property
    @pulumi.getter(name="notificationEmails")
    def notification_emails(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        List of email addresses where the system sends notifications about activations and deactivations of the stream
        """
        return pulumi.get(self, "notification_emails")

    @property
    @pulumi.getter(name="oracleConnector")
    def oracle_connector(self) -> pulumi.Output[Optional['outputs.DatastreamOracleConnector']]:
        return pulumi.get(self, "oracle_connector")

    @property
    @pulumi.getter(name="papiJson")
    def papi_json(self) -> pulumi.Output[str]:
        """
        The configuration in JSON format that can be copy-pasted into PAPI configuration to enable datastream behavior
        """
        return pulumi.get(self, "papi_json")

    @property
    @pulumi.getter(name="productId")
    def product_id(self) -> pulumi.Output[str]:
        """
        The ID of the product for which the stream was created
        """
        return pulumi.get(self, "product_id")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output[Sequence[str]]:
        """
        Identifies the properties monitored in the stream
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="s3Connector")
    def s3_connector(self) -> pulumi.Output[Optional['outputs.DatastreamS3Connector']]:
        return pulumi.get(self, "s3_connector")

    @property
    @pulumi.getter(name="splunkConnector")
    def splunk_connector(self) -> pulumi.Output[Optional['outputs.DatastreamSplunkConnector']]:
        return pulumi.get(self, "splunk_connector")

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> pulumi.Output[str]:
        """
        The name of the stream
        """
        return pulumi.get(self, "stream_name")

    @property
    @pulumi.getter(name="streamVersion")
    def stream_version(self) -> pulumi.Output[int]:
        """
        Identifies the configuration version of the stream
        """
        return pulumi.get(self, "stream_version")

    @property
    @pulumi.getter(name="sumologicConnector")
    def sumologic_connector(self) -> pulumi.Output[Optional['outputs.DatastreamSumologicConnector']]:
        return pulumi.get(self, "sumologic_connector")

